// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from qb_softhand_industry_srvs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice
#include "qb_softhand_industry_srvs/srv/detail/get_measurements__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Request__init(qb_softhand_industry_srvs__srv__GetMeasurements_Request * msg)
{
  if (!msg) {
    return false;
  }
  // max_repeats
  // get_position
  // get_current
  // get_velocity
  return true;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Request__fini(qb_softhand_industry_srvs__srv__GetMeasurements_Request * msg)
{
  if (!msg) {
    return;
  }
  // max_repeats
  // get_position
  // get_current
  // get_velocity
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Request__are_equal(const qb_softhand_industry_srvs__srv__GetMeasurements_Request * lhs, const qb_softhand_industry_srvs__srv__GetMeasurements_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // max_repeats
  if (lhs->max_repeats != rhs->max_repeats) {
    return false;
  }
  // get_position
  if (lhs->get_position != rhs->get_position) {
    return false;
  }
  // get_current
  if (lhs->get_current != rhs->get_current) {
    return false;
  }
  // get_velocity
  if (lhs->get_velocity != rhs->get_velocity) {
    return false;
  }
  return true;
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Request__copy(
  const qb_softhand_industry_srvs__srv__GetMeasurements_Request * input,
  qb_softhand_industry_srvs__srv__GetMeasurements_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // max_repeats
  output->max_repeats = input->max_repeats;
  // get_position
  output->get_position = input->get_position;
  // get_current
  output->get_current = input->get_current;
  // get_velocity
  output->get_velocity = input->get_velocity;
  return true;
}

qb_softhand_industry_srvs__srv__GetMeasurements_Request *
qb_softhand_industry_srvs__srv__GetMeasurements_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_softhand_industry_srvs__srv__GetMeasurements_Request * msg = (qb_softhand_industry_srvs__srv__GetMeasurements_Request *)allocator.allocate(sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Request));
  bool success = qb_softhand_industry_srvs__srv__GetMeasurements_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Request__destroy(qb_softhand_industry_srvs__srv__GetMeasurements_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_softhand_industry_srvs__srv__GetMeasurements_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__init(qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_softhand_industry_srvs__srv__GetMeasurements_Request * data = NULL;

  if (size) {
    data = (qb_softhand_industry_srvs__srv__GetMeasurements_Request *)allocator.zero_allocate(size, sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_softhand_industry_srvs__srv__GetMeasurements_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_softhand_industry_srvs__srv__GetMeasurements_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__fini(qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_softhand_industry_srvs__srv__GetMeasurements_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence *
qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * array = (qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence *)allocator.allocate(sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__destroy(qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__are_equal(const qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * lhs, const qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_softhand_industry_srvs__srv__GetMeasurements_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence__copy(
  const qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * input,
  qb_softhand_industry_srvs__srv__GetMeasurements_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_softhand_industry_srvs__srv__GetMeasurements_Request * data =
      (qb_softhand_industry_srvs__srv__GetMeasurements_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_softhand_industry_srvs__srv__GetMeasurements_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_softhand_industry_srvs__srv__GetMeasurements_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_softhand_industry_srvs__srv__GetMeasurements_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Response__init(qb_softhand_industry_srvs__srv__GetMeasurements_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // position
  // current
  // velocity
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    qb_softhand_industry_srvs__srv__GetMeasurements_Response__fini(msg);
    return false;
  }
  return true;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Response__fini(qb_softhand_industry_srvs__srv__GetMeasurements_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // position
  // current
  // velocity
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Response__are_equal(const qb_softhand_industry_srvs__srv__GetMeasurements_Response * lhs, const qb_softhand_industry_srvs__srv__GetMeasurements_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // position
  if (lhs->position != rhs->position) {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // velocity
  if (lhs->velocity != rhs->velocity) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  return true;
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Response__copy(
  const qb_softhand_industry_srvs__srv__GetMeasurements_Response * input,
  qb_softhand_industry_srvs__srv__GetMeasurements_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // position
  output->position = input->position;
  // current
  output->current = input->current;
  // velocity
  output->velocity = input->velocity;
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  return true;
}

qb_softhand_industry_srvs__srv__GetMeasurements_Response *
qb_softhand_industry_srvs__srv__GetMeasurements_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_softhand_industry_srvs__srv__GetMeasurements_Response * msg = (qb_softhand_industry_srvs__srv__GetMeasurements_Response *)allocator.allocate(sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Response));
  bool success = qb_softhand_industry_srvs__srv__GetMeasurements_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Response__destroy(qb_softhand_industry_srvs__srv__GetMeasurements_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    qb_softhand_industry_srvs__srv__GetMeasurements_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__init(qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_softhand_industry_srvs__srv__GetMeasurements_Response * data = NULL;

  if (size) {
    data = (qb_softhand_industry_srvs__srv__GetMeasurements_Response *)allocator.zero_allocate(size, sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = qb_softhand_industry_srvs__srv__GetMeasurements_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        qb_softhand_industry_srvs__srv__GetMeasurements_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__fini(qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      qb_softhand_industry_srvs__srv__GetMeasurements_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence *
qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * array = (qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence *)allocator.allocate(sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__destroy(qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__are_equal(const qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * lhs, const qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!qb_softhand_industry_srvs__srv__GetMeasurements_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence__copy(
  const qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * input,
  qb_softhand_industry_srvs__srv__GetMeasurements_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(qb_softhand_industry_srvs__srv__GetMeasurements_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    qb_softhand_industry_srvs__srv__GetMeasurements_Response * data =
      (qb_softhand_industry_srvs__srv__GetMeasurements_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!qb_softhand_industry_srvs__srv__GetMeasurements_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          qb_softhand_industry_srvs__srv__GetMeasurements_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!qb_softhand_industry_srvs__srv__GetMeasurements_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
