// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_softhand_industry_srvs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_HPP_
#define QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Request __attribute__((deprecated))
#else
# define DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Request __declspec(deprecated)
#endif

namespace qb_softhand_industry_srvs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMeasurements_Request_
{
  using Type = GetMeasurements_Request_<ContainerAllocator>;

  explicit GetMeasurements_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_repeats = 0l;
      this->get_position = false;
      this->get_current = false;
      this->get_velocity = false;
    }
  }

  explicit GetMeasurements_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_repeats = 0l;
      this->get_position = false;
      this->get_current = false;
      this->get_velocity = false;
    }
  }

  // field types and members
  using _max_repeats_type =
    int32_t;
  _max_repeats_type max_repeats;
  using _get_position_type =
    bool;
  _get_position_type get_position;
  using _get_current_type =
    bool;
  _get_current_type get_current;
  using _get_velocity_type =
    bool;
  _get_velocity_type get_velocity;

  // setters for named parameter idiom
  Type & set__max_repeats(
    const int32_t & _arg)
  {
    this->max_repeats = _arg;
    return *this;
  }
  Type & set__get_position(
    const bool & _arg)
  {
    this->get_position = _arg;
    return *this;
  }
  Type & set__get_current(
    const bool & _arg)
  {
    this->get_current = _arg;
    return *this;
  }
  Type & set__get_velocity(
    const bool & _arg)
  {
    this->get_velocity = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Request
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Request
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMeasurements_Request_ & other) const
  {
    if (this->max_repeats != other.max_repeats) {
      return false;
    }
    if (this->get_position != other.get_position) {
      return false;
    }
    if (this->get_current != other.get_current) {
      return false;
    }
    if (this->get_velocity != other.get_velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMeasurements_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMeasurements_Request_

// alias to use template instance with default allocator
using GetMeasurements_Request =
  qb_softhand_industry_srvs::srv::GetMeasurements_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_softhand_industry_srvs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Response __attribute__((deprecated))
#else
# define DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Response __declspec(deprecated)
#endif

namespace qb_softhand_industry_srvs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetMeasurements_Response_
{
  using Type = GetMeasurements_Response_<ContainerAllocator>;

  explicit GetMeasurements_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->position = 0;
      this->current = 0;
      this->velocity = 0;
    }
  }

  explicit GetMeasurements_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->position = 0;
      this->current = 0;
      this->velocity = 0;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _position_type =
    int16_t;
  _position_type position;
  using _current_type =
    int16_t;
  _current_type current;
  using _velocity_type =
    int16_t;
  _velocity_type velocity;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__position(
    const int16_t & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__current(
    const int16_t & _arg)
  {
    this->current = _arg;
    return *this;
  }
  Type & set__velocity(
    const int16_t & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Response
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__GetMeasurements_Response
    std::shared_ptr<qb_softhand_industry_srvs::srv::GetMeasurements_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetMeasurements_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->current != other.current) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetMeasurements_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetMeasurements_Response_

// alias to use template instance with default allocator
using GetMeasurements_Response =
  qb_softhand_industry_srvs::srv::GetMeasurements_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

namespace qb_softhand_industry_srvs
{

namespace srv
{

struct GetMeasurements
{
  using Request = qb_softhand_industry_srvs::srv::GetMeasurements_Request;
  using Response = qb_softhand_industry_srvs::srv::GetMeasurements_Response;
};

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

#endif  // QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__GET_MEASUREMENTS__STRUCT_HPP_
