// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from qb_softhand_industry_srvs:srv/SetCommands.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__SET_COMMANDS__FUNCTIONS_H_
#define QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__SET_COMMANDS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "qb_softhand_industry_srvs/msg/rosidl_generator_c__visibility_control.h"

#include "qb_softhand_industry_srvs/srv/detail/set_commands__struct.h"

/// Initialize srv/SetCommands message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * qb_softhand_industry_srvs__srv__SetCommands_Request
 * )) before or use
 * qb_softhand_industry_srvs__srv__SetCommands_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Request__init(qb_softhand_industry_srvs__srv__SetCommands_Request * msg);

/// Finalize srv/SetCommands message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Request__fini(qb_softhand_industry_srvs__srv__SetCommands_Request * msg);

/// Create srv/SetCommands message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * qb_softhand_industry_srvs__srv__SetCommands_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
qb_softhand_industry_srvs__srv__SetCommands_Request *
qb_softhand_industry_srvs__srv__SetCommands_Request__create();

/// Destroy srv/SetCommands message.
/**
 * It calls
 * qb_softhand_industry_srvs__srv__SetCommands_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Request__destroy(qb_softhand_industry_srvs__srv__SetCommands_Request * msg);

/// Check for srv/SetCommands message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Request__are_equal(const qb_softhand_industry_srvs__srv__SetCommands_Request * lhs, const qb_softhand_industry_srvs__srv__SetCommands_Request * rhs);

/// Copy a srv/SetCommands message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Request__copy(
  const qb_softhand_industry_srvs__srv__SetCommands_Request * input,
  qb_softhand_industry_srvs__srv__SetCommands_Request * output);

/// Initialize array of srv/SetCommands messages.
/**
 * It allocates the memory for the number of elements and calls
 * qb_softhand_industry_srvs__srv__SetCommands_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__init(qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * array, size_t size);

/// Finalize array of srv/SetCommands messages.
/**
 * It calls
 * qb_softhand_industry_srvs__srv__SetCommands_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__fini(qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * array);

/// Create array of srv/SetCommands messages.
/**
 * It allocates the memory for the array and calls
 * qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence *
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__create(size_t size);

/// Destroy array of srv/SetCommands messages.
/**
 * It calls
 * qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__destroy(qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * array);

/// Check for srv/SetCommands message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__are_equal(const qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * lhs, const qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * rhs);

/// Copy an array of srv/SetCommands messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence__copy(
  const qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * input,
  qb_softhand_industry_srvs__srv__SetCommands_Request__Sequence * output);

/// Initialize srv/SetCommands message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * qb_softhand_industry_srvs__srv__SetCommands_Response
 * )) before or use
 * qb_softhand_industry_srvs__srv__SetCommands_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Response__init(qb_softhand_industry_srvs__srv__SetCommands_Response * msg);

/// Finalize srv/SetCommands message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Response__fini(qb_softhand_industry_srvs__srv__SetCommands_Response * msg);

/// Create srv/SetCommands message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * qb_softhand_industry_srvs__srv__SetCommands_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
qb_softhand_industry_srvs__srv__SetCommands_Response *
qb_softhand_industry_srvs__srv__SetCommands_Response__create();

/// Destroy srv/SetCommands message.
/**
 * It calls
 * qb_softhand_industry_srvs__srv__SetCommands_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Response__destroy(qb_softhand_industry_srvs__srv__SetCommands_Response * msg);

/// Check for srv/SetCommands message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Response__are_equal(const qb_softhand_industry_srvs__srv__SetCommands_Response * lhs, const qb_softhand_industry_srvs__srv__SetCommands_Response * rhs);

/// Copy a srv/SetCommands message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Response__copy(
  const qb_softhand_industry_srvs__srv__SetCommands_Response * input,
  qb_softhand_industry_srvs__srv__SetCommands_Response * output);

/// Initialize array of srv/SetCommands messages.
/**
 * It allocates the memory for the number of elements and calls
 * qb_softhand_industry_srvs__srv__SetCommands_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__init(qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * array, size_t size);

/// Finalize array of srv/SetCommands messages.
/**
 * It calls
 * qb_softhand_industry_srvs__srv__SetCommands_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__fini(qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * array);

/// Create array of srv/SetCommands messages.
/**
 * It allocates the memory for the array and calls
 * qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence *
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__create(size_t size);

/// Destroy array of srv/SetCommands messages.
/**
 * It calls
 * qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
void
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__destroy(qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * array);

/// Check for srv/SetCommands message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__are_equal(const qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * lhs, const qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * rhs);

/// Copy an array of srv/SetCommands messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_qb_softhand_industry_srvs
bool
qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence__copy(
  const qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * input,
  qb_softhand_industry_srvs__srv__SetCommands_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__SET_COMMANDS__FUNCTIONS_H_
