// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_softhand_industry_srvs:srv/GetMeasurements.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__GET_MEASUREMENTS__TRAITS_HPP_
#define QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__GET_MEASUREMENTS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_softhand_industry_srvs/srv/detail/get_measurements__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_softhand_industry_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetMeasurements_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: max_repeats
  {
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << ", ";
  }

  // member: get_position
  {
    out << "get_position: ";
    rosidl_generator_traits::value_to_yaml(msg.get_position, out);
    out << ", ";
  }

  // member: get_current
  {
    out << "get_current: ";
    rosidl_generator_traits::value_to_yaml(msg.get_current, out);
    out << ", ";
  }

  // member: get_velocity
  {
    out << "get_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.get_velocity, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetMeasurements_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: max_repeats
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << "\n";
  }

  // member: get_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_position: ";
    rosidl_generator_traits::value_to_yaml(msg.get_position, out);
    out << "\n";
  }

  // member: get_current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_current: ";
    rosidl_generator_traits::value_to_yaml(msg.get_current, out);
    out << "\n";
  }

  // member: get_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "get_velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.get_velocity, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetMeasurements_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

namespace rosidl_generator_traits
{

[[deprecated("use qb_softhand_industry_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_softhand_industry_srvs::srv::GetMeasurements_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_softhand_industry_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_softhand_industry_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_softhand_industry_srvs::srv::GetMeasurements_Request & msg)
{
  return qb_softhand_industry_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_softhand_industry_srvs::srv::GetMeasurements_Request>()
{
  return "qb_softhand_industry_srvs::srv::GetMeasurements_Request";
}

template<>
inline const char * name<qb_softhand_industry_srvs::srv::GetMeasurements_Request>()
{
  return "qb_softhand_industry_srvs/srv/GetMeasurements_Request";
}

template<>
struct has_fixed_size<qb_softhand_industry_srvs::srv::GetMeasurements_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<qb_softhand_industry_srvs::srv::GetMeasurements_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<qb_softhand_industry_srvs::srv::GetMeasurements_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace qb_softhand_industry_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetMeasurements_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    rosidl_generator_traits::value_to_yaml(msg.position, out);
    out << ", ";
  }

  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetMeasurements_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position: ";
    rosidl_generator_traits::value_to_yaml(msg.position, out);
    out << "\n";
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetMeasurements_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

namespace rosidl_generator_traits
{

[[deprecated("use qb_softhand_industry_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_softhand_industry_srvs::srv::GetMeasurements_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_softhand_industry_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_softhand_industry_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_softhand_industry_srvs::srv::GetMeasurements_Response & msg)
{
  return qb_softhand_industry_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_softhand_industry_srvs::srv::GetMeasurements_Response>()
{
  return "qb_softhand_industry_srvs::srv::GetMeasurements_Response";
}

template<>
inline const char * name<qb_softhand_industry_srvs::srv::GetMeasurements_Response>()
{
  return "qb_softhand_industry_srvs/srv/GetMeasurements_Response";
}

template<>
struct has_fixed_size<qb_softhand_industry_srvs::srv::GetMeasurements_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<qb_softhand_industry_srvs::srv::GetMeasurements_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<qb_softhand_industry_srvs::srv::GetMeasurements_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<qb_softhand_industry_srvs::srv::GetMeasurements>()
{
  return "qb_softhand_industry_srvs::srv::GetMeasurements";
}

template<>
inline const char * name<qb_softhand_industry_srvs::srv::GetMeasurements>()
{
  return "qb_softhand_industry_srvs/srv/GetMeasurements";
}

template<>
struct has_fixed_size<qb_softhand_industry_srvs::srv::GetMeasurements>
  : std::integral_constant<
    bool,
    has_fixed_size<qb_softhand_industry_srvs::srv::GetMeasurements_Request>::value &&
    has_fixed_size<qb_softhand_industry_srvs::srv::GetMeasurements_Response>::value
  >
{
};

template<>
struct has_bounded_size<qb_softhand_industry_srvs::srv::GetMeasurements>
  : std::integral_constant<
    bool,
    has_bounded_size<qb_softhand_industry_srvs::srv::GetMeasurements_Request>::value &&
    has_bounded_size<qb_softhand_industry_srvs::srv::GetMeasurements_Response>::value
  >
{
};

template<>
struct is_service<qb_softhand_industry_srvs::srv::GetMeasurements>
  : std::true_type
{
};

template<>
struct is_service_request<qb_softhand_industry_srvs::srv::GetMeasurements_Request>
  : std::true_type
{
};

template<>
struct is_service_response<qb_softhand_industry_srvs::srv::GetMeasurements_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__GET_MEASUREMENTS__TRAITS_HPP_
