// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_softhand_industry_srvs:srv/SetCommand.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__SET_COMMAND__STRUCT_HPP_
#define QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__SET_COMMAND__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Request __attribute__((deprecated))
#else
# define DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Request __declspec(deprecated)
#endif

namespace qb_softhand_industry_srvs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetCommand_Request_
{
  using Type = SetCommand_Request_<ContainerAllocator>;

  explicit SetCommand_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_repeats = 0l;
      this->set_commands = false;
      this->position_command = 0;
    }
  }

  explicit SetCommand_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_repeats = 0l;
      this->set_commands = false;
      this->position_command = 0;
    }
  }

  // field types and members
  using _max_repeats_type =
    int32_t;
  _max_repeats_type max_repeats;
  using _set_commands_type =
    bool;
  _set_commands_type set_commands;
  using _position_command_type =
    int16_t;
  _position_command_type position_command;

  // setters for named parameter idiom
  Type & set__max_repeats(
    const int32_t & _arg)
  {
    this->max_repeats = _arg;
    return *this;
  }
  Type & set__set_commands(
    const bool & _arg)
  {
    this->set_commands = _arg;
    return *this;
  }
  Type & set__position_command(
    const int16_t & _arg)
  {
    this->position_command = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Request
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Request
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetCommand_Request_ & other) const
  {
    if (this->max_repeats != other.max_repeats) {
      return false;
    }
    if (this->set_commands != other.set_commands) {
      return false;
    }
    if (this->position_command != other.position_command) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetCommand_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetCommand_Request_

// alias to use template instance with default allocator
using SetCommand_Request =
  qb_softhand_industry_srvs::srv::SetCommand_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_softhand_industry_srvs


#ifndef _WIN32
# define DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Response __attribute__((deprecated))
#else
# define DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Response __declspec(deprecated)
#endif

namespace qb_softhand_industry_srvs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetCommand_Response_
{
  using Type = SetCommand_Response_<ContainerAllocator>;

  explicit SetCommand_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SetCommand_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Response
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_softhand_industry_srvs__srv__SetCommand_Response
    std::shared_ptr<qb_softhand_industry_srvs::srv::SetCommand_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetCommand_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetCommand_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetCommand_Response_

// alias to use template instance with default allocator
using SetCommand_Response =
  qb_softhand_industry_srvs::srv::SetCommand_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

namespace qb_softhand_industry_srvs
{

namespace srv
{

struct SetCommand
{
  using Request = qb_softhand_industry_srvs::srv::SetCommand_Request;
  using Response = qb_softhand_industry_srvs::srv::SetCommand_Response;
};

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

#endif  // QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__SET_COMMAND__STRUCT_HPP_
