// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from qb_softhand_industry_srvs:srv/Trigger.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__TRIGGER__TRAITS_HPP_
#define QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__TRIGGER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "qb_softhand_industry_srvs/srv/detail/trigger__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace qb_softhand_industry_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Trigger_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: max_repeats
  {
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Trigger_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: max_repeats
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_repeats: ";
    rosidl_generator_traits::value_to_yaml(msg.max_repeats, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Trigger_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

namespace rosidl_generator_traits
{

[[deprecated("use qb_softhand_industry_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_softhand_industry_srvs::srv::Trigger_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_softhand_industry_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_softhand_industry_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_softhand_industry_srvs::srv::Trigger_Request & msg)
{
  return qb_softhand_industry_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_softhand_industry_srvs::srv::Trigger_Request>()
{
  return "qb_softhand_industry_srvs::srv::Trigger_Request";
}

template<>
inline const char * name<qb_softhand_industry_srvs::srv::Trigger_Request>()
{
  return "qb_softhand_industry_srvs/srv/Trigger_Request";
}

template<>
struct has_fixed_size<qb_softhand_industry_srvs::srv::Trigger_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<qb_softhand_industry_srvs::srv::Trigger_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<qb_softhand_industry_srvs::srv::Trigger_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace qb_softhand_industry_srvs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Trigger_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Trigger_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Trigger_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace qb_softhand_industry_srvs

namespace rosidl_generator_traits
{

[[deprecated("use qb_softhand_industry_srvs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const qb_softhand_industry_srvs::srv::Trigger_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  qb_softhand_industry_srvs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use qb_softhand_industry_srvs::srv::to_yaml() instead")]]
inline std::string to_yaml(const qb_softhand_industry_srvs::srv::Trigger_Response & msg)
{
  return qb_softhand_industry_srvs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<qb_softhand_industry_srvs::srv::Trigger_Response>()
{
  return "qb_softhand_industry_srvs::srv::Trigger_Response";
}

template<>
inline const char * name<qb_softhand_industry_srvs::srv::Trigger_Response>()
{
  return "qb_softhand_industry_srvs/srv/Trigger_Response";
}

template<>
struct has_fixed_size<qb_softhand_industry_srvs::srv::Trigger_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<qb_softhand_industry_srvs::srv::Trigger_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<qb_softhand_industry_srvs::srv::Trigger_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<qb_softhand_industry_srvs::srv::Trigger>()
{
  return "qb_softhand_industry_srvs::srv::Trigger";
}

template<>
inline const char * name<qb_softhand_industry_srvs::srv::Trigger>()
{
  return "qb_softhand_industry_srvs/srv/Trigger";
}

template<>
struct has_fixed_size<qb_softhand_industry_srvs::srv::Trigger>
  : std::integral_constant<
    bool,
    has_fixed_size<qb_softhand_industry_srvs::srv::Trigger_Request>::value &&
    has_fixed_size<qb_softhand_industry_srvs::srv::Trigger_Response>::value
  >
{
};

template<>
struct has_bounded_size<qb_softhand_industry_srvs::srv::Trigger>
  : std::integral_constant<
    bool,
    has_bounded_size<qb_softhand_industry_srvs::srv::Trigger_Request>::value &&
    has_bounded_size<qb_softhand_industry_srvs::srv::Trigger_Response>::value
  >
{
};

template<>
struct is_service<qb_softhand_industry_srvs::srv::Trigger>
  : std::true_type
{
};

template<>
struct is_service_request<qb_softhand_industry_srvs::srv::Trigger_Request>
  : std::true_type
{
};

template<>
struct is_service_response<qb_softhand_industry_srvs::srv::Trigger_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // QB_SOFTHAND_INDUSTRY_SRVS__SRV__DETAIL__TRIGGER__TRAITS_HPP_
